VERSION 5.00
Begin VB.Form amqsaiemFrm 
   Caption         =   "MQSeries Visual Basic Sample"
   ClientHeight    =   6645
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7980
   Icon            =   "amqsaiem.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6645
   ScaleWidth      =   7980
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton HelpButton 
      Caption         =   "&Help"
      Height          =   375
      Left            =   2160
      TabIndex        =   7
      Top             =   6120
      Width           =   1455
   End
   Begin VB.CommandButton aboutButton 
      Caption         =   "&About"
      Height          =   375
      Left            =   3840
      TabIndex        =   8
      Top             =   6120
      Width           =   1455
   End
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   480
      Left            =   7320
      Picture         =   "amqsaiem.frx":030A
      ScaleHeight     =   480
      ScaleWidth      =   480
      TabIndex        =   14
      Top             =   6120
      Width           =   480
   End
   Begin VB.Frame Frame2 
      Caption         =   "Queue Manager And Queue"
      Height          =   1935
      Left            =   120
      TabIndex        =   11
      Top             =   120
      Width           =   7695
      Begin VB.CommandButton runButton 
         Caption         =   "&Display Events"
         Height          =   375
         Left            =   4080
         TabIndex        =   2
         Top             =   1440
         Width           =   1575
      End
      Begin VB.CommandButton stopButton 
         Caption         =   "&Stop"
         Enabled         =   0   'False
         Height          =   375
         Left            =   5880
         TabIndex        =   3
         Top             =   1440
         Width           =   1575
      End
      Begin VB.TextBox QMgrTBox 
         Height          =   375
         Left            =   1800
         TabIndex        =   0
         Top             =   240
         Width           =   5655
      End
      Begin VB.TextBox QTBox 
         Height          =   375
         Left            =   1800
         TabIndex        =   1
         Top             =   840
         Width           =   5655
      End
      Begin VB.Label waitLbl 
         Caption         =   "Waiting for an event..."
         Height          =   255
         Left            =   360
         TabIndex        =   15
         Top             =   1440
         Visible         =   0   'False
         Width           =   3375
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         Caption         =   "Event Queue Name:"
         Height          =   255
         Left            =   240
         TabIndex        =   13
         Top             =   840
         Width           =   1455
      End
      Begin VB.Label Label1 
         Alignment       =   1  'Right Justify
         Caption         =   "Queue Manager:"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   360
         Width           =   1455
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Output"
      Height          =   3855
      Left            =   120
      TabIndex        =   9
      Top             =   2160
      Width           =   7695
      Begin VB.CheckBox clearCheck 
         Caption         =   "C&lear output window for each event"
         Height          =   255
         Left            =   3000
         TabIndex        =   5
         Top             =   3360
         Width           =   2895
      End
      Begin VB.CommandButton clearButton 
         Caption         =   "&Clear Now"
         Height          =   375
         Left            =   6120
         TabIndex        =   6
         Top             =   3360
         Width           =   1215
      End
      Begin VB.ListBox eventsLBox 
         BeginProperty Font 
            Name            =   "Fixedsys"
            Size            =   9
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   2985
         Left            =   120
         MultiSelect     =   2  'Extended
         TabIndex        =   4
         Top             =   240
         Width           =   7215
      End
   End
   Begin VB.CommandButton quitButton 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   5520
      TabIndex        =   10
      Top             =   6120
      Width           =   1455
   End
End
Attribute VB_Name = "amqsaiemFrm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'******************************************************************************'
'*                                                                            *'
'* Program name: AMQSAIEM.VBP                                                 *'
'*                                                                            *'
'* Description:  Sample Visual Basic program to demonstrate a basic event     *'
'*               monitor using the MQSeries Admin Interface (MQAI).           *'
'*                                                                            *'
'* Statement:    Licensed Materials - Property of IBM                         *'
'*               04L1830, 5639-B43                                            *'
'*                                                                            *'
'*               (C) Copyright IBM Corp. 1998                                 *'
'*                                                                            *'
'******************************************************************************'
'*                                                                            *'
'* Function:                                                                  *'
'*    AMQSAIEM is a sample Visual Basic program that demonstrates how to      *'
'*    write a simple event monitor using the MQAI call mqGetBag and other     *'
'*    MQAI calls.                                                             *'
'*                                                                            *'
'*    The name of the event queue to be monitored is passed as a parameter    *'
'*    to the program. This would usually be one of the system event queues:-  *'
'*            SYSTEM.ADMIN.QMGR.EVENT        Queue Manager events             *'
'*            SYSTEM.ADMIN.PERFM.EVENT       Performance events               *'
'*            SYSTEM.ADMIN.CHANNEL.EVENT     Channel events                   *'
'*    To monitor the Queue Manager event queue or the Performance event queue *'
'*    the attributes of the Queue Manager will need to be changed to enable   *'
'*    the events, refer to the Programmable System Management book Part 1 for *'
'*    more information. The Queue Manager attributes can be changed either by *'
'*    MQSC commands or using the MQAI interface.                              *'
'*    Channel events are enabled by default.                                  *'
'*                                                                            *'
'* Program logic                                                              *'
'*    Connect to the Queue Manager.                                           *'
'*    Open the requested event queue with the wait unlimited option.          *'
'*    Wait for a message and when it arrives get the message from the queue   *'
'*    and format it into an MQAI bag with the call mqGetBag.                  *'
'*    There are many types of event messages and it is beyond the scope of    *'
'*    this sample to program for all event messages. Instead print out the    *'
'*    contents of the formatted bag.                                          *'
'*    Loop around to wait for another message until either there is an error  *'
'*    or the program is stopped by a user interrupt.                          *'
'*                                                                            *'
'******************************************************************************'

Option Explicit

Dim Hconn As Long         ' Handle to queue manager
Dim bQueueOK As Long      ' Keep reading msgs while true
Dim EventQueue As Long    ' Handle to event queue

Private Sub aboutButton_Click()
  aboutDialog.Show
End Sub

Private Sub clearButton_Click()
  eventsLBox.Clear
End Sub

Private Sub Form_Load()
  '******************************************************************************'
  '* Set up defaults                                                            *'
  '******************************************************************************'
  
  MQ_SETDEFAULTS
  aboutDialog.mqInfoTBox.Text = "MQSeries Visual Basic Sample" & Chr(13) & Chr(10) & "Using the MQAI to display events"
End Sub

Private Sub Form_Terminate()
  quitButton_Click
End Sub

Private Sub Form_Unload(Cancel As Integer)
  quitButton_Click
End Sub

Private Sub HelpButton_Click()
  Me.Enabled = False
  amqsaiemHlpFrm.Show
End Sub

Private Sub runButton_Click()

   Const VBQMNameLength = MQ_Q_MGR_NAME_LENGTH + 1

   Dim QMName As String * VBQMNameLength      ' Queue manager name
   Dim QName As String                        ' Queue name
   Dim Reason As Long                         ' Reason code
   Dim ConnReason As Long                     ' MQCONN reason code
   Dim CompCode As Long                       ' Completion code

   '**************************************************************************'
   '* Connect to the queue manager                                           *'
   '**************************************************************************'
   QMName = QMgrTBox.Text
   QName = QTBox.Text
   If QName = "" Then
     DisplayError "Please enter the name of an event queue"
   Else
     If QMName = "" Then QMName = " "
     MQCONN QMName, Hconn, CompCode, ConnReason
  
     '***************************************************************************'
     '* Report the reason and stop if the connection failed                     *'
     '***************************************************************************'
     If CompCode = MQCC_FAILED Then
         DisplayError "MQCONN failed with code " & ConnReason
         End
     End If
  
     stopButton.Enabled = True
     runButton.Enabled = False
     waitLbl.Visible = True
  
     '***************************************************************************'
     '* Call the routine to open the event queue and format any event messages  *'
     '* read from the queue.                                                    *'
     '***************************************************************************'
     GetQEvents Hconn, QName
  
     '***************************************************************************'
     '* Disconnect from the queue manager if not already connected              *'
     '***************************************************************************'
     If ConnReason <> MQRC_ALREADY_CONNECTED Then
        MQDISC Hconn, CompCode, Reason
        If CompCode <> MQCC_OK Then
          DisplayError "MQDISC failed with code " & Reason
        End If
     End If
  End If
End Sub

Sub GetQEvents(Hconn As Long, QName As String)
   '******************************************************************************'
   '*                                                                            *'
   '* Function: GetQEvents                                                       *'
   '*                                                                            *'
   '******************************************************************************'
   '*                                                                            *'
   '* Input Parameters:  Handle to the QueueManager                              *'
   '*                    Name of the event queue to be monitored                 *'
   '*                                                                            *'
   '* Output Parameters: None                                                    *'
   '*                                                                            *'
   '* Logic:   Open the event queue.                                             *'
   '*          Get a message off the event queue and format the message into     *'
   '*          a bag.                                                            *'
   '*          A real event monitor would need to be programmed to deal with     *'
   '*          each type of event that it receives from the queue. This is       *'
   '*          outside the scope of this sample so instead the contents of       *'
   '*          the bag are printed.                                              *'
   '*          The program waits forever for a message on the queue so the       *'
   '*          program must be terminated by a user interrupt (^C).              *'
   '*                                                                            *'
   '******************************************************************************'
   
   Dim OpenReason As Long    ' MQOPEN reason code
   Dim Reason As Long        ' Reason code
   Dim CompCode As Long      ' Completion code
   Dim EventBag As Long      ' Event bag to receive event msg
   Dim od As MQOD            ' Object Descriptor
   Dim md As MQMD            ' Message Descriptor
   Dim gmo As MQGMO          ' Get message options

   EventBag = MQHB_UNUSABLE_HBAG
   od = MQOD_DEFAULT
   md = MQMD_DEFAULT
   gmo = MQGMO_DEFAULT
   bQueueOK = True
   
   

   '***************************************************************************'
   '* Create an Event Bag in which to receive the event, message exit the     *'
   '* function if the create fails.                                           *'
   '***************************************************************************'
   mqCreateBag MQCBO_USER_BAG, EventBag, CompCode, Reason
   If CompCode <> MQCC_OK Then
     DisplayError "mqCreateBag failed with code " & Reason
     quitButton_Click
   End If
   If CompCode = MQCC_OK Then
  
     '***************************************************************************'
     '* Open the event queue chosen by the user                                 *'
     '***************************************************************************'
     od.ObjectName = QName
     MQOPEN Hconn, od, (MQOO_INPUT_AS_Q_DEF + MQOO_FAIL_IF_QUIESCING), EventQueue, CompCode, OpenReason
     If CompCode <> MQCC_OK Then
       DisplayError "MQOPEN failed with code " & OpenReason
       quitButton_Click
     End If
  
     '***************************************************************************'
     '* Set the GMO options to control the action of the get message from the   *'
     '* queue.                                                                  *'
     '***************************************************************************'
     gmo.Options = MQGMO_NO_WAIT + MQGMO_FAIL_IF_QUIESCING
     gmo.Version = MQGMO_VERSION_2                ' Avoid need to reset Message id
     gmo.MatchOptions = MQMO_NONE                 ' and Correlation id after every
                                                  ' mqGetBag
  
     '***************************************************************************'
     '* If open failed we cannot access the queue and must stop the monitor.    *'
     '***************************************************************************'
     If CompCode <> MQCC_OK Then bQueueOK = 0
  
     '***************************************************************************'
     '* Main loop to get an event message when it arrives                       *'
     '***************************************************************************'
     While bQueueOK
       '*************************************************************************'
       '* Get the message from the event queue and convert it into the event    *'
       '* bag. In the C sample, this is done using the MQWI_UNLIMITED option    *'
       '* with MQGET. Using this in Visual Basic stops VB from responding to    *'
       '* events, so this sample repeatedly tries mqGetBag until a bag is       *'
       '* available, some other error occurs, or bQueueOk is set to False by    *'
       '* the user pressing the Stop button.                                    *'
       '*************************************************************************'
       Do
         mqGetBag Hconn, EventQueue, md, gmo, EventBag, CompCode, Reason
         DoEvents
       Loop Until (Reason <> MQRC_NO_MSG_AVAILABLE) Or (Not bQueueOK)
       If (CompCode <> MQCC_OK) And (Reason <> MQRC_NO_MSG_AVAILABLE) Then
         DisplayError "mqGetBag failed with code " & Reason
         quitButton_Click
       End If
  
       If CompCode <> MQCC_OK Then
         bQueueOK = False
       Else
         '***********************************************************************'
         '* Event message read - display the contents of the event bag          *'
         '***********************************************************************'
         If clearCheck.Value = 1 Then eventsLBox.Clear
         waitLbl.Visible = False
         If PrintBag(EventBag) Then Debug.Print "Error found while printing bag contents"
         waitLbl.Visible = True
       End If
     Wend
     
 
     '***************************************************************************'
     '* Close the event queue if successfully opened                            *'
     '***************************************************************************'
     If OpenReason = MQRC_NONE Then
        MQCLOSE Hconn, EventQueue, MQCO_NONE, CompCode, Reason
        If CompCode <> MQCC_OK Then
          DisplayError "MQCLOSE failed with code " & Reason
          quitButton_Click
        End If
     End If
  
     '***************************************************************************'
     '* Delete the event bag if successfully created.                           *'
     '***************************************************************************'
     If EventBag <> MQHB_UNUSABLE_HBAG Then
        mqDeleteBag EventBag, CompCode, Reason
        If CompCode <> MQCC_OK Then
          DisplayError "mqDeleteBag failed with code " & Reason
          quitButton_Click
        End If
     End If
   End If
End Sub

Function PrintBag(DataBag As Long) As Integer
   '******************************************************************************'
   '*                                                                            *'
   '* Function: PrintBag                                                         *'
   '*                                                                            *'
   '******************************************************************************'
   '*                                                                            *'
   '* Input Parameters:  Bag Handle                                              *'
   '*                                                                            *'
   '* Output Parameters: None                                                    *'
   '*                                                                            *'
   '* Returns:           Number of errors found                                  *'
   '*                                                                            *'
   '* Logic: Calls PrintBagContents to display the contents of the bag.          *'
   '*                                                                            *'
   '******************************************************************************'

    PrintBag = PrintBagContents(DataBag, 0)
End Function

Function PrintBagContents(DataBag As Long, Indent As Integer) As Integer

   '******************************************************************************'
   '*                                                                            *'
   '* Function: PrintBagContents                                                 *'
   '*                                                                            *'
   '******************************************************************************'
   '*                                                                            *'
   '* Input Parameters:  Bag Handle                                              *'
   '*                    Indentation level of bag                                *'
   '*                                                                            *'
   '* Output Parameters: None                                                    *'
   '*                                                                            *'
   '* Returns:           Number of errors found                                  *'
   '*                                                                            *'
   '* Logic: Count the number of items in the bag                                *'
   '*        Obtain selector and item type for each item in the bag.             *'
   '*        Obtain the value of the item depending on item type and display the *'
   '*        index of the item, the selector and the value.                      *'
   '*        If the item is an embedded bag handle then call this function again *'
   '*        to print the contents of the embedded bag increasing the            *'
   '*        indentation level.                                                  *'
   '*                                                                            *'
   '******************************************************************************'

   Const Length = 255                     ' Max length of string to be read
   Const IncIndent = 2                    ' Number of spaces to indent
                                          ' embedded bag display

   Dim ItemCount As Long                  ' Number of items in the bag
   Dim ItemType As Long                   ' Type of the item
   Dim I As Integer                       ' Index of item in the bag
   Dim StringVal As String * Length       ' Value if item is a string
   Dim StringLength As Long               ' Length of string value
   Dim Ccsid As Long                      ' CCSID of string value
   Dim iValue As Long                     ' Value if item is an integer
   Dim Selector As Long                   ' Selector of item
   Dim BagHandle As Long                  ' Value if item is a bag handle
   Dim Reason As Long                     ' reason code
   Dim CompCode As Long                   ' completion code
   Dim TrimLength As Long                 ' Length of string to be trimmed
   Dim Errors As Integer                  ' Count of errors found
   Dim Info As String                     ' Information to be displayed

   Errors = 0

   '***************************************************************************'
   '* Count the number of items in the bag                                    *'
   '***************************************************************************'
   mqCountItems DataBag, MQSEL_ALL_SELECTORS, ItemCount, CompCode, Reason

   If CompCode <> MQCC_OK Then
      Errors = Errors + 1
   Else
      eventsLBox.AddItem String(Indent, " ") & "Handle: " & DataBag & "  Size: " & ItemCount
      eventsLBox.AddItem "Index: Selector: Value:"
   End If

   '***************************************************************************'
   '* If no errors found then display each item in the bag                    *'
   '***************************************************************************'
   If Not Errors Then
      For I = 0 To (ItemCount - 1)
        '********************************************************************'
        '* First inquire the type of the item for each item in the bag      *'
        '********************************************************************'
        mqInquireItemInfo DataBag, MQSEL_ANY_SELECTOR, I, Selector, ItemType, CompCode, Reason

        If CompCode <> MQCC_OK Then Errors = Errors + 1

          Select Case ItemType
            Case MQIT_INTEGER
              '***************************************************************'
              '* Item is an integer. Find its value and display its index,   *'
              '* selector and value.                                         *'
              '***************************************************************'
              mqInquireInteger DataBag, MQSEL_ANY_SELECTOR, I, iValue, CompCode, Reason

               If CompCode <> MQCC_OK Then
                  Errors = Errors + 1
               Else
                 Info = BuildInfoString(I, Selector, Indent)
                 Info = Info + "(" + Format$(iValue) + ")"
                 eventsLBox.AddItem Info
               End If

          Case MQIT_STRING:
               '***************************************************************'
               '* Item is a string. Obtain the string in a buffer, prepare    *'
               '* the string for displaying and display the index, selector,  *'
               '* string and character set id.                                *'
               '***************************************************************'
               'StringVal = String(Length, vbNullChar)
               mqInquireString DataBag, MQSEL_ANY_SELECTOR, I, Length, StringVal, StringLength, Ccsid, CompCode, Reason

               If CompCode = MQCC_FAILED Then
                   Errors = Errors + 1
               Else
                 Info = BuildInfoString(I, Selector, Indent)
                 Info = Info + "'" + Trim$(StringVal) + "'"
                 Info = Info + "  " & Format$(Ccsid)
                 eventsLBox.AddItem Info
               End If

          Case MQIT_BAG:
               '***************************************************************'
               '* Item is an embedded bag handle, so call the function again  *'
               '* to display the contents.                                    *'
               '***************************************************************'
               mqInquireBag DataBag, MQSEL_ANY_SELECTOR, I, BagHandle, CompCode, Reason

               If CompCode <> MQCC_OK Then
                  Errors = Errors + 1
               Else
                  Info = BuildInfoString(I, Selector, Indent)
                  Info = Info & BagHandle
                  eventsLBox.AddItem Info
                  eventsLBox.AddItem String(Indent + IncIndent, " "), "System Bag:"
                  Errors = Errors + PrintBagContents(BagHandle, Indent + IncIndent)
               End If
          Case Else
               eventsLBox.AddItem String(Indent, " ") & "Unknown object type"
          End Select
      Next
      eventsLBox.AddItem String(60, "-")
   End If
   PrintBagContents = Errors
End Function

Function BuildInfoString(ByVal Value1 As Integer, ByVal Value2 As Integer, ByVal Indent As Integer) As String
  '******************************************************************************'
  '* This function is used to build up the first 2 columns of the output,       *'
  '* adding spaces to pad out as necessary.                                     *'
  '* Input parameters:                                                          *'
  '*   ByVal Value1 As Integer - the first column of the output                 *'
  '*   ByVal Value2 As Integer - the second column of the output                *'
  '*   ByVal Indent As Integer - the number of space to be prepended            *'
  '******************************************************************************'
  
  BuildInfoString = String(Indent + 2, " ")
  BuildInfoString = BuildInfoString & Value1
  BuildInfoString = BuildInfoString + String(8 - Len(Format$(Value1)), " ")
  BuildInfoString = BuildInfoString & Value2
  BuildInfoString = BuildInfoString + String(9 - Len(Format$(Value2)), " ")
End Function

Private Sub quitButton_Click()
  '******************************************************************************'
  '* Attempts to close the event queue and disconnect from the queue manager    *'
  '* before exitting                                                            *'
  '******************************************************************************'

  Dim CompCode As Long, Reason As Long
  If Hconn <> 0 Then
    If EventQueue <> 0 Then MQCLOSE Hconn, EventQueue, MQCO_NONE, CompCode, Reason
    MQDISC Hconn, CompCode, Reason
  End If
  End
End Sub

Sub DisplayError(ByVal Message As String)
' Displays an error message in a message box and beeps
  Beep
  MsgBox Message, vbOKOnly + vbExclamation, "Error"
End Sub

Private Sub stopButton_Click()
  '******************************************************************************'
  '* Stops the application listening for events                                 *'
  '******************************************************************************'
  bQueueOK = False
  stopButton.Enabled = False
  runButton.Enabled = True
  waitLbl.Visible = False
End Sub
